# GNUmakefile.self: let tesla build tesla

CC=		gcc

UNIT=		tesla
UNIT_DIR=	../tesla

INCLUDE_DIRS=	.. ../.. ../../gp ../../tom ../../tom/trt \
		../../../x-tom/tom ../../../x-tom/tom/trt

READABLE=	-freadable-c

LIBS=		-lm -ldl -lpthread
CFLAGS=		-w
ALL_CFLAGS=	-pipe -g -O -I . $(CFLAGS) $(patsubst %, -I %, $(INCLUDE_DIRS))

TOM_SRC=	Argument.t Assignment.t BlockBody.t BlockDefinition.t C.t Callable.t Compound.t Expression.t Extension.t Invocation.t Loop.t Meta.t Method.t MethodBody.t Selector.t Special.t TomFile.t Type.t Unit.t Variable.t extensions.t tesla.t tom.t various.t config.t

TOM_GEN=	$(TOM_SRC:.t=.c) $(UNIT)-r.c $(UNIT)-r.h
OBJ=		$(TOM_SRC:.t=.o) $(UNIT)-r.o

ifeq ($(GC_PTH),)
GC_PTH=		250000
endif

ifeq ($(TOM_ROOT),)
TOM_ROOT=	../../../x-tom/tom
endif

%.o: %.c
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

all: alset

force: clean alset
force-self: clean alself

alset: $(OBJ)
	time gcc $(OBJ) -o $@ ../tesla-config/.libs/libtesla-config.a ../../mu/.libs/libmu.a ../../gp/gps/.libs/libgps.a $(TOM_ROOT)/C/.libs/libC.a $(TOM_ROOT)/tom/.libs/libtom.a $(TOM_ROOT)/trt/.libs/libtrt.a $(LIBS)

alself: $(OBJ)
	time gcc $(OBJ) -o $@ ../tesla-config/.libs/libtesla-config.a ../unit/mu/libmu.a ../unit/gps/libgps.a ../unit/C/libC.a ../unit/tom/libtom.a ../../tom/trt/.libs/libtrt.a  ../unit/_builtin_/lib_builtin_.a $(LIBS)

$(TOM_GEN): .stamp-prepare

bootcode: .stamp-force
	cp -p $(TOM_GEN) ../bootstrap/tesla/

.stamp-prepare: $(patsubst %,$(UNIT_DIR)/%, $(TOM_SRC))
	time $(TESLA) :cc-pre :cc-post -1 $(READABLE) -u $(UNIT) -I $(UNIT_DIR) $(patsubst %, -I %, $(INCLUDE_DIRS)) :gc-stat :gc-pth $(GC_PTH)
	touch $@

.stamp-force:  $(patsubst %,$(UNIT_DIR)/%, $(TOM_SRC))
	time $(TESLA) -F :cc-pre :cc-post -1 $(READABLE) -u $(UNIT) -I $(UNIT_DIR) $(patsubst %, -I %, $(INCLUDE_DIRS)) :gc-stat :gc-pth $(GC_PTH)
	touch $@

clean:
	$(RM) $(TOM_GEN) $(OBJ) $(UNIT)-r.h alset alself \
		.libs .stamp-prepare .stamp-force
